'use strict';

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

var _helper = require('./helper');

var _helper2 = _interopRequireDefault(_helper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ERROR_ID = 'form.errors.presence';

function test(value) {
  return (0, _helper2.default)((0, _index.presence)()(value));
}

describe('Validator: presence', function () {
  it('should be invalid when `value` is empty', function () {
    _assert2.default.strictEqual(ERROR_ID, test());
    _assert2.default.strictEqual(ERROR_ID, test(null));
    _assert2.default.strictEqual(ERROR_ID, test(''));
    _assert2.default.strictEqual(ERROR_ID, test('   '));
    _assert2.default.strictEqual(ERROR_ID, test(' \n \t '));
    _assert2.default.strictEqual(ERROR_ID, test(new FileList()));
    _assert2.default.strictEqual(ERROR_ID, test(new FileList({ length: 0 })));
    _assert2.default.strictEqual(ERROR_ID, test(new FileList([])));
    _assert2.default.strictEqual(ERROR_ID, (0, _helper2.default)((0, _index.required)()(' \n \t '))); // Alias
  });
  it('should be valid when `value` is not empty', function () {
    _assert2.default.ok(!test(1));
    _assert2.default.ok(!test('str'));
    _assert2.default.ok(!test(' abc '));
    _assert2.default.ok(!test(new File()));
    _assert2.default.ok(!test(new FileList({ length: 1 })));
    _assert2.default.ok(!test(new FileList([{}])));
    _assert2.default.ok(!(0, _helper2.default)((0, _index.required)()(' abc ')));
  });
  it('should use formatMessage', function () {
    var defaultValue = _index2.default.formatMessage;

    _index2.default.formatMessage = function (msg) {
      return Object.assign({}, msg, { id: msg.id + '2' });
    };
    _assert2.default.strictEqual(ERROR_ID + '2', test(''));

    _index2.default.formatMessage = defaultValue;
  });
});